﻿package com.wastedpotential {
	import flash.display.MovieClip;
	import flash.events.Event;
    import org.papervision3d.lights.PointLight3D;
	import org.papervision3d.materials.ColorMaterial;
	import org.papervision3d.materials.shadematerials.FlatShadeMaterial;
	import org.papervision3d.objects.DisplayObject3D;
    import org.papervision3d.materials.utils.MaterialsList;
	import org.papervision3d.events.FileLoadEvent;
	import org.papervision3d.view.stats.StatsView;
    import org.papervision3d.objects.parsers.Collada;
	
	public class ColladaContent extends PaperBase {
      	   
	   	private var light:PointLight3D;
		private var container:DisplayObject3D;
		private var cars:Array = [];  
		private var cmat:ColorMaterial;
		private var fmat:FlatShadeMaterial;
		private var numCarsLoaded:int;
		private var NUM_CARS:int = 5; //Change this value to change the number of cars displayed
		
		public function ColladaContent() {
        	init();
			var stats:StatsView = new StatsView(renderer);
			this.addChild(stats);
		}
      
       	override protected function init3d():void {
			default_camera.z = -30000;
			light = new PointLight3D();
			light.x = 0;
			light.y = 1000;
			light.z = -1000;
			
			cmat = new ColorMaterial(0xff0000);
			var matList:MaterialsList =  new MaterialsList();
			matList.addMaterial(cmat, "redmaterial");
			matList.addMaterial(cmat, "blackmaterial");
			
			container = new DisplayObject3D();
			container.rotationY = 40;
			container.rotationX = -20;
			
			//I load the model 5 times to help exaggerate any performance difference between the Collada and Max3DS models:
			numCarsLoaded = 0;
			for(var i:int=0; i<NUM_CARS; i++) {
				var car:Collada = new Collada("models/wagon5.DAE", matList); 
				car.addEventListener(FileLoadEvent.LOAD_COMPLETE, onModelLoaded);
				car.addEventListener(FileLoadEvent.LOAD_PROGRESS, onModelProgress);
				car.addEventListener(FileLoadEvent.LOAD_ERROR, onModelError);				
				car.scale = 1;
				car.z = i*35000;
				cars.push(car);
			}			
		}
      
		private function onModelLoaded(e:FileLoadEvent):void {
			numCarsLoaded++;
			if (numCarsLoaded >= NUM_CARS) {
				for(var i:int=0; i<NUM_CARS; i++) {
					fmat = new FlatShadeMaterial(light, 0x231f20, 0x00ff00);
					cars[i].getChildByName("Chassis", true).material = fmat;
					cars[i].getChildByName("FLWheel", true).material = fmat;
					cars[i].getChildByName("FRWheel", true).material = fmat;
					cars[i].getChildByName("RRWheel", true).material = fmat;
					cars[i].getChildByName("RLWheel", true).material = fmat;
					container.addChild(cars[i]);			
				}
				default_scene.addChild(container);
			}
			modelLoadText_mc.modelLoad_txt.text = "";	
		}
		
		private function onModelProgress(e:FileLoadEvent):void {
			modelLoadText_mc.modelLoad_txt.text = "PLEASE WAIT WHILE THE MODELS LOAD\nTHIS MAY TAKE A FEW MINUTES";
		}
		
		private function onModelError(e:FileLoadEvent):void {
			modelLoadText_mc.modelLoad_txt.text = "MODEL LOAD ERROR";
		}
	  
       	override protected function processFrame():void {
			default_camera.y = -(((mouseY - (stage.height / 2)) / stage.height) * 10000);
			default_camera.x = (((mouseX - (stage.width / 2)) / stage.width) * 10000);
			for(var i:int=0; i<NUM_CARS; i++) {
				cars[i].yaw(1); //turn the cars 1 degree
			}
       	}	      
    }    
}